precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform vec3 iResolution;

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    float imh = iResolution.y;
    float imw = iResolution.x;
    float imx = float( iResolution.x - imw ) / 2.0 ;
    float imy = float( iResolution.y - imh ) / 2.0 ;

    if ( fragCoord.x > imx &&
         fragCoord.x < imx+imw &&
         fragCoord.y > imy &&
         fragCoord.y < imy+imh )
    {
        vec2 uv = fragCoord.xy / iResolution.xy;
        vec4 rgba = texture2D(inputImageTexture, uv);
        float x = ( fragCoord.x - imx ) / imw;
        float y = ( fragCoord.y - imy ) / imh;
        float e0 = x;
        float e1 = 1.0-x;
        float e2 = y;
        float e3 = 1.0-y;
        float scl = 1.0;
        if ( e0 <= e1 && e0 <= e2 && e0 <= e3 && e0 < 0.1 )
            scl = 1.2;
        if ( e1 <= e0 && e1 <= e2 && e1 <= e3 && e1 < 0.1 )
            scl = 0.5;
        if ( e2 <= e1 && e2 <= e0 && e2 <= e3 && e2 < 0.1 )
            scl = 1.5;
        if ( e3 <= e1 && e3 <= e2 && e3 <= e0 && e3 < 0.1 )
            scl = 0.7;
        fragColor = rgba * scl;
    }
    else
    {
        fragColor = vec4(0,0,0.5,1);
    }
}

void main(){
    mainImage(gl_FragColor, textureCoordinate * iResolution.xy );
}