precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform vec3 iResolution;


void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
	vec2 texCoords = fragCoord.xy / iResolution.xy;
    vec4 texColor = texture2D(inputImageTexture, texCoords);
    float offsetX = iResolution.x/20.0;
    float offsetY = offsetX*iResolution.x/iResolution.y;
    if(fragCoord.x<offsetX||fragCoord.x>iResolution.x-offsetX||
      fragCoord.y<offsetY||fragCoord.y>iResolution.y-offsetY){
        fragColor = vec4(1.0,1.0,1.0,1.0);
    }else{
        fragColor = texColor;
    }
}

void main(){
    mainImage(gl_FragColor, textureCoordinate * iResolution.xy );
}