precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform vec3 iResolution;
uniform float iTime;

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
	vec2 uv = fragCoord.xy / iResolution.xy;
	vec2 delta = vec2(sin(iTime)/40.0, 0);
	vec4 txt = texture2D(inputImageTexture,uv.xy);
	txt.r = texture2D(inputImageTexture,uv.xy+delta ).r;
	txt.b = texture2D(inputImageTexture,uv.xy-delta ).b;
	fragColor = txt;
}

void main(){
    mainImage(gl_FragColor, textureCoordinate * iResolution.xy );
}





