precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform vec3 iResolution;
uniform float ratio;

vec2 mosaicSize;

void main() {

    mosaicSize = vec2(ratio, ratio);

    vec2 intXY = vec2(textureCoordinate.x*iResolution.x, textureCoordinate.y*iResolution.y);//点(x,y)在纹理中的实际坐标

    vec2 XYMosaic = vec2(floor(intXY.x/mosaicSize.x)*mosaicSize.x, floor(intXY.y/mosaicSize.y)*mosaicSize.y);//点(x,y)所属哪一行哪一列的小矩形

    vec2 UVMosaic = vec2(XYMosaic.x/iResolution.x, XYMosaic.y/iResolution.y);//把该矩形看做一个大的像素点其纹理坐标就是UVMosaic
    vec4 color = texture2D(inputImageTexture, UVMosaic);//取出对应纹理坐标的文素
    gl_FragColor = color;
}