precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform vec3 iResolution;
uniform float ratio;

vec2 mosaicSize;

void main () {

    mosaicSize = vec2(ratio, ratio);

    vec2 intXY = vec2(textureCoordinate.x*iResolution.x, textureCoordinate.y*iResolution.y);

    vec2 XYMosaic = vec2(floor(intXY.x/mosaicSize.x)*mosaicSize.x, floor(intXY.y/mosaicSize.y)*mosaicSize.y) + 0.5*mosaicSize;

    vec2 delXY = XYMosaic - intXY;
    float delL = length(delXY);
    vec2 UVMosaic = vec2(XYMosaic.x/iResolution.x, XYMosaic.y/iResolution.y);

    vec4 _finalColor;
    if (delL< 0.5*mosaicSize.x)
    _finalColor = texture2D(inputImageTexture, UVMosaic);
    else
    _finalColor = texture2D(inputImageTexture, textureCoordinate);

    gl_FragColor = _finalColor;
}