precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform vec3 iResolution;
uniform vec4 iMouse;
uniform float ratio;

#define PI 3.14159

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    float effectRadius = 0.5;
    float effectAngle = ratio * PI;

    vec2 center = iMouse.xy / iResolution.xy;
    center = center == vec2(0, 0) ? vec2(0.5, 0.5) : center;

    vec2 uv = fragCoord.xy / iResolution.xy - center;

    float len = length(uv * vec2(iResolution.x / iResolution.y, 1.0));
    float angle = atan(uv.y, uv.x) + effectAngle * smoothstep(effectRadius, 0.0, len);
    float radius = length(uv);

    fragColor = texture2D(inputImageTexture, vec2(radius * cos(angle), radius * sin(angle)) + center);

}

void main(){
    mainImage(gl_FragColor, textureCoordinate * iResolution.xy );
}





