precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform float ratio;//表示旋转的角度

const float PI = 3.14159265;
const float uR = 0.5;

void main() {

    ivec2 ires = ivec2(512, 512);//假设纹理由 512 * 512个像素点
    float Res = float(ires.y);//直径
    vec2 st = textureCoordinate;//纹理坐标（映射坐标）
    float Radius = Res * uR;//半径
    vec2 xy = Res * st;//在圆上任意采样点的实际纹理位置
    vec2 dxy = xy - vec2(Res/2., Res/2.);// 采样点到圆心的向量
    float r = length(dxy);//采样点到圆心的距离
    float attenValue = (1.0 -(r/Radius)*(r/Radius));//抛物线递减因子
    float beta = atan(dxy.y, dxy.x) + radians(ratio) * 2.0 * attenValue;//旋转的角度
    if (r <= Radius)
    {
        xy = Res/2.0 + r * vec2(cos(beta), sin(beta));
    }
    st = xy/Res;//实际纹理位置转化成纹理坐标（0到1）
    vec3 irgb = texture2D(inputImageTexture, st).rgb;
    gl_FragColor = vec4(irgb, 1.0);

}





