precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform vec3 iResolution;
uniform float strength;


void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
	vec2 uv = fragCoord.xy / iResolution.xy;

    vec4 color = texture2D(inputImageTexture, uv);

    float x = (uv.x + 4.0 ) * (uv.y + 4.0 ) * (10.0);
	vec4 grain = vec4(mod((mod(x, 13.0) + 1.0) * (mod(x, 123.0) + 1.0), 0.01)-0.005) * strength;

	fragColor = color + grain;
}


void main(){
    mainImage(gl_FragColor, textureCoordinate * iResolution.xy );
}





