varying highp vec2 textureCoordinate;
precision highp float;

uniform sampler2D inputImageTexture;
uniform sampler2D curve;
uniform float strength;

void main()
{
    lowp vec4 textureColor;
    lowp vec4 originalTextureColor;
    lowp vec4 textureColorRes;
    lowp vec4 textureColorOri;
    vec4 grey1Color;
    vec4 layerColor;

    float xCoordinate = textureCoordinate.x;
    float yCoordinate = textureCoordinate.y;

    highp float redCurveValue;
    highp float greenCurveValue;
    highp float blueCurveValue;

    originalTextureColor = textureColor = texture2D(inputImageTexture, vec2(xCoordinate, yCoordinate));
    textureColorRes = textureColor;
    textureColorOri = textureColor;

    textureColor = 1.0 - ((1.0 - textureColorOri) * (1.0 - textureColorOri));
    textureColor = (textureColor - textureColorOri) + textureColorOri;

    redCurveValue = texture2D(curve, vec2(textureColor.r, 0.0)).r;
    greenCurveValue = texture2D(curve, vec2(textureColor.g, 0.0)).g;
    blueCurveValue = texture2D(curve, vec2(textureColor.b, 0.0)).b;

    highp float G = (redCurveValue + greenCurveValue + blueCurveValue);
    G = G / 3.0;

    redCurveValue = -.15 * G + 1.15 * redCurveValue;
    greenCurveValue = -.15 * G + 1.15 * greenCurveValue;
    blueCurveValue = -.15 * G + 1.15 * blueCurveValue;

    textureColor = vec4(redCurveValue, greenCurveValue, blueCurveValue, 1.0);

    gl_FragColor = mix(originalTextureColor, vec4(textureColor.r, textureColor.g, textureColor.b, 1.0), strength);
}
